import java.io.PrintWriter
import scala.virtualization.lms.common.LiftNumeric

object Example4Generator extends Example4ScalaGen { val IR = Example4Runner }

object Example4Runner extends Example4 with Example4OpsExp {
  def main(args: Array[String]) {
    Example4Generator.emitSource((x: Rep[Unit]) => run(), "Application", new PrintWriter(System.out))
  }
}

trait Example4 extends Example4Ops with LiftNumeric {
  def run() = {
    val x0 = Matrix[Int](10,10)
    val b = x0*x0*x0*x0*1
    println(b)
    println(x0) // what forces b to be printed before x0?

    x0(5,5) = 10
    println(x0) // what forces this to happen after the update?
  }
}